# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

message() {
	printf %s\\n "alterator-lilo: $*" >&2
}

debug() {
	message "$*"
}

error() {
	local out="$(printf %s\\n "$*" |simple_quote)"
	printf '(error "%s")\n' "$out"
}

fatal() {
	message "$*"
	exit 1
}

# quote argument for sed regexp.
quote_sed_regexp() {
	local out="$*"
	if [ -z "${out##*[\[\].^\$\\/\*]*}" ]; then
		out="$(printf %s "$out" |sed -e 's/[]\.\*^$[\\/]/\\&/g')" ||
			return 1
	fi
	printf %s "$out"
}

# quote argument for shell.
quote_shell() {
	local out="$*"
	if [ -z "${out##*[\"\$\`\\]*}" ]; then
		out="$(printf %s "$out" |sed -e 's/["$`\]/\\&/g')" ||
			return 1
	fi
	printf %s "$out"
}

partitions_list() {
	grep '^/dev/' "$fdisk_out"
}

disk_list() {
	sed -ne 's/^Disk \([^:]\+\): \([^,]\+\),.*/\1 \2/p' "$fdisk_out"
}

fdisk_output() {
	[ "$#" -eq 1 ] ||
		fatal "Output file required"

	fdisk -l 2>/dev/null |
		grep '^\(/dev\|Disk \)' |
		grep -v '/dev/dm-' |
		sed -r	-e 's#[[:space:]]+# #g' \
			-e 's#^(/dev/[^[:space:]]+) ([[:digit:]])#\1 x \2#' > "$1"
}

find_devname() {
	sed -n -e 's/^Disk \([^:]\+\): \([^,]\+\),.*/\1/p' "$fdisk_out"|head -n1
}
