# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

getinfo() {
	local dev= cur_dev= cur= id=
	debug "getinfo()"

	cur_dev="$(sed -rne 's,^boot=\"(.*)\"$,\1,p' "$globals")" || return 0
	cur_dev="/dev/${cur_dev#/dev/}"

	# Show disks
	disk_list |
	while read dev size; do
		[ "$cur_dev" != "$dev" ] && cur="#f" || cur="#t"
		printf '("%s" size "%s" disk #t cur %s)\n' "${dev#/dev/}" "$size" "$cur"
	done

	# Show partitions
	partitions_list |cut -d\  -f1,6 |
	while read dev id; do
		case "$id" in
			5|82) continue ;;
		esac
		[ "$cur_dev" != "$dev" ] && cur="#f" || cur="#t"
		size="$(fdisk -l "$dev" 2>/dev/null |sed -ne 's/^Disk[[:space:]]\+[^:]\+:[[:space:]]\+\([^,]\+\),.*/\1/p')"
		printf '("%s" size "%s" disk #f cur %s)\n' "${dev#/dev/}" "$size" "$cur"
	done
}
