# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

openclose_cdrom() {
	local cdrom devname param value

	systool -b ide -v |
		sed -r -n \
			-e 's/[[:space:]]+//g' \
			-e 's/^(Device|media|drivename)="(.*)"$/\1 \2/p' |
	while read -r param value; do
		case "$param" in
			Device)
				devname= cdrom=
				;;
			media)
				[ "$value" != 'cdrom' ] ||
					cdrom=1
				;;
			drivename)
				devname="/dev/$value"
				;;
		esac
		[ -n "$cdrom" -a -b "${devname:-}" ] ||
			continue

		debug "openclose cdrom: $devname"
		openclose "$devname" ||:

		devname= cdrom=
	done
}
