# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

increment() {
	local var="$1" cur
	cur="$(eval echo \$$var)"
	[ -n "$cur" ] || cur=0
	eval "$var=\$((\$$var + 1))"
}

find_others() {
	local cnf="$1"
	local dev boot start end blocks id system label
	local dev mpoint dummy exclude=" "

	debug "find_others(): cnf='$cnf'"

	# Remember self partitions
	while read dev mpoint dummy; do
		[ -z "${mpoint%%$destdir}" ] || continue
		exclude="$exclude$dev "
	done < /proc/mounts

	debug "find_others(): exclude='$exclude'"

	partitions_list |
	while read dev boot start end blocks id system; do
		# We need only bootable partitions
		[ "$boot" = "*" ] || continue

		# Exclude self mountpoints
		[ -n "${exclude##* $dev *}" ] || continue

		case "$id" in
			1|4|6|7|b|c|e|f|11|14|16|17|1b|1c|1e|86|87|c1|c4|c6|ef)
				label="Windows${win_n:+_$win_n}"
				increment win_n
				;;
			81|83|85|88|8e|f0|fd)
				label="Other${other_n:+_$other_n}"
				increment other_n
				;;
			*)
				continue
				;;
		esac
		bootsector "$dev" >&2 || continue

		debug "find_others(): label='$label' dev='$dev'"

		printf 'other="%s"\nlabel="%s"\n' "$dev" "$label" >>"$cnf"
	done
}
