; ***** BEGIN LICENSE BLOCK *****
; * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; *
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; * GNU General Public License for more details.
; *
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
; ***** END LICENSE BLOCK *****

(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-lilo")

(define lilo-conf-data (woo-get-option (car (woo-try "read-source" "/lilo")) 'source ""))

(define (change url)
	(frame:replace url))

(define (load-lilo-conf)
	(let ((data (woo-catch/message (thunk (woo-get-option (car (woo-try "read-source" "/lilo")) 'source)))))
		(lilo-conf text data)))

(define (write-changes)
	(woo-catch/message (thunk (woo-try "write-source" "/lilo" 'source (lilo-conf text)))))

(define (write-all)
	(woo-catch/message (thunk (write-changes)
				  (woo-try "commit" "/lilo")
				  (woo-try "commit" "/autoinstall/lilo"))))

(define (reset-changes)
	(lilo-conf text (woo-catch/message (thunk
			(woo-get-option (car (woo-try "read-source" "/lilo")) 'source)))))

(hbox
	align 'center
	(button (_ "Normal mode") (when clicked (change "/lilo")))
	(button (_ "Global options") (when clicked (change "/lilo/extra-general")))
	(button (_ "Operation systems") (when clicked (change "/lilo/extra-sections")))
	(button (_ "Other loaders") (when clicked (change "/lilo/extra-other"))))

(groupbox ""
	(document:id lilo-conf (textbox lilo-conf-data))
	(hbox align 'center
		(document:id save-button  (button (_ "Save")  (when clicked (write-changes))))
		(document:id reset-button (button (_ "Reset") (when clicked (reset-changes))))))
(or
	(global 'frame:next)
	(hbox
		(button (_ "Apply") (when clicked (write-all)))
		(button (_ "Quit" ) (when clicked (document:end)))))
(and
	(global 'frame:next)
	(frame:on-next (thunk (or (write-all) 'cancel))))

(document:root (when loaded
			(and (global 'frame:next) (frame:back-activity #f))
			(load-lilo-conf)))
